package com.supervision.police.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.supervision.police.domain.ComDictionary;
import com.supervision.police.dto.KeyAndNameObject;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 * 字典表 Mapper 接口
 * </p>
 *
 * @author dw
 * @since 2021-11-17
 */
@Repository
public interface ComDictionaryMapper extends BaseMapper<ComDictionary> {

    List<ComDictionary> queryAllChildrenInfoForPid(@Param("pid") Long id);

    /**
     * 更新所有id, pid为 所传参数 的数据状态为0
     * 逻辑删除
     * @param id 字典id
     */
    Long updateDataStatusByIdAndPid(@Param("id") Long id);

    /**
     * 根据type和code唯一确定一项
     *
     * @return
     */
    ComDictionary queryDicByTypeAndCode(@Param("code") String code,
                                        @Param("type") String type);

    //根据type和name唯一确定一项
    ComDictionary queryByTypeAndName(@Param("type") String type,
                                     @Param("name") String name);

    //根据type和name唯一确定一项
    String queryDicByTypeAndName(@Param("type") String type,
                                 @Param("name") String name);

    /**
     * 查询出字典所有分类
     */
    List<String> queryAllType();

    List<KeyAndNameObject> queryIndustry(@Param("type") String type);
}
